SystemOrganization addCategory: #'Pier-Slideshow'!

PRWidget subclass: #PRSlideshow
	instanceVariableNames: 'structure slides current ajaxId'
	classVariableNames: 'NoChildrenFound'
	poolDictionaries: ''
	category: 'Pier-Slideshow'!

!PRSlideshow class methodsFor: 'accessing-descriptions' stamp: 'lr 8/22/2007 13:25'!
descriptionFirstLast
	^ MABooleanDescription new
		selectorAccessor: #firstLast;
		label: 'Navigation Control';
		checkboxLabel: 'First/Last';
		default: true;
		priority: 200;
		yourself! !

!PRSlideshow class methodsFor: 'accessing-descriptions' stamp: 'lr 8/22/2007 13:26'!
descriptionPrevNext
	^ MABooleanDescription new
		selectorAccessor: #prevNext;
		checkboxLabel: 'Previous/Next';
		default: true;
		priority: 210;
		yourself! !

!PRSlideshow class methodsFor: 'accessing-descriptions' stamp: 'lr 8/22/2007 13:56'!
descriptionSlideList
	^ MABooleanDescription new
		selectorAccessor: #slideList;
		checkboxLabel: 'Slide Listing';
		default: true;
		priority: 220;
		yourself! !

!PRSlideshow class methodsFor: 'initialization' stamp: 'lr 8/22/2007 11:59'!
initialize
	NoChildrenFound := PRPage named: 'unnamed'.
	NoChildrenFound
		contents: 'Please add slides to this widget.'! !

!PRSlideshow class methodsFor: 'testing' stamp: 'lr 8/22/2007 11:51'!
isAbstract
	^ false! !

!PRSlideshow class methodsFor: 'accessing' stamp: 'lr 8/22/2007 11:53'!
label
	^ 'Slideshow'! !

!PRSlideshow methodsFor: 'accessing' stamp: 'lr 8/22/2007 12:14'!
current
	"Answer the current slides to display."
	
	^ current ifNil: [ 
		current := self slides isEmpty
			ifFalse: [ self slides first ]
			ifTrue: [ NoChildrenFound ] ]! !

!PRSlideshow methodsFor: 'accessing' stamp: 'lr 8/22/2007 12:04'!
current: aStructure
	current := aStructure! !

!PRSlideshow methodsFor: 'actions' stamp: 'lr 8/22/2007 12:10'!
goFirst
	"Go to the first slide."
	
	self current: self slides first! !

!PRSlideshow methodsFor: 'actions' stamp: 'lr 8/22/2007 12:10'!
goLast
	"Go to the last slide."
	
	self current: self slides last! !

!PRSlideshow methodsFor: 'actions' stamp: 'lr 8/22/2007 12:08'!
goNext
	"Go to the next slide."
	
	self current: (self slides
		after: self current 
		ifAbsent: [ self slides first ])! !

!PRSlideshow methodsFor: 'actions' stamp: 'lr 8/22/2007 12:10'!
goPrev
	"Go to the previous slide."
	
	self current: (self slides
		before: self current 
		ifAbsent: [ self slides last ])! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 8/22/2007 12:05'!
renderContentOn: html
	html div
		class: 'slideshow';
		id: (ajaxId := html nextId);
		with: [ self renderSlideshowOn: html ]! !

!PRSlideshow methodsFor: 'rendering-private' stamp: 'lr 8/22/2007 13:17'!
renderControl: aString class: aClassString enabled: aBoolean action: aBlock on: html
	aBoolean
		ifTrue: [
			html anchor
				callback: aBlock;
				class: aClassString;
				onClick: (html updater
					id: ajaxId;
					callback: [ :r | 
						aBlock value.
						self renderSlideshowOn: r ];
					return: false);
				with: aString ]
		ifFalse: [
			html span
				class: aClassString;
				with: aString ]! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 8/22/2007 13:18'!
renderControlFirstOn: html
	self 
		renderControl: '|<' class: 'first'
		enabled: self current ~= self slides first
		action: [ self goFirst ] on: html! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 8/22/2007 13:18'!
renderControlLastOn: html
	self 
		renderControl: '>|' class: 'last'
		enabled: self current ~= self slides last
		action: [ self goLast ] on: html! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 8/22/2007 13:20'!
renderControlNextOn: html
	self 
		renderControl: '>>' class: 'next'
		enabled: self current ~= self slides last
		action: [ self goNext ] on: html! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 8/22/2007 13:20'!
renderControlPrevOn: html
	self 
		renderControl: '<<' class: 'prev'
		enabled: self current ~= self slides first
		action: [ self goPrev ] on: html! !

!PRSlideshow methodsFor: 'rendering-controls' stamp: 'lr 8/22/2007 13:56'!
renderControlSlideListOn: html
	| selectId |
	html select
		class: 'navg';
		list: self slides;
		selected: self current;
		id: (selectId := html nextId);
		callback: [ :value | self current: value ];
		labels: [ :value | (self slides indexOf: value) asString , '. ' , value title ];
		onChange: (html updater
			id: ajaxId;
			triggerFormElement: selectId;
			callback: [ :r | self renderSlideshowOn: r ])! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 8/22/2007 13:56'!
renderControlsOn: html
	html div class: 'tools'; with: [
		(self read: #descriptionFirstLast)
			ifTrue: [ self renderControlFirstOn: html ].
		(self read: #descriptionPrevNext)
			ifTrue: [ self renderControlPrevOn: html ].
		(self read: #descriptionSlideList)
			ifTrue: [ self renderControlSlideListOn: html ].
		(self read: #descriptionPrevNext)
			ifTrue: [ self renderControlNextOn: html ].
		(self read: #descriptionFirstLast)
			ifTrue: [ self renderControlLastOn: html ] ]! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 8/22/2007 11:55'!
renderSlideOn: html
	html div 
		class: 'slide'; 
		with: [ self context renderer visit: self current ]! !

!PRSlideshow methodsFor: 'rendering' stamp: 'lr 8/22/2007 13:12'!
renderSlideshowOn: html
	self renderSlideOn: html.
	self slides isEmpty
		ifFalse: [ self renderControlsOn: html ]! !

!PRSlideshow methodsFor: 'accessing' stamp: 'lr 8/22/2007 12:04'!
slides
	"Answer the possible slides to display."
	
	^ slides ifNil: [ slides := self structure enumerator contents ]! !

!PRSlideshow methodsFor: 'accessing' stamp: 'lr 8/22/2007 11:51'!
structure
	"Answer the owning structure, the structure this component is defined at."
	
	^ self context componentDictionary keyAtValue: self ifAbsent: [ nil ]! !
PRSlideshow initialize!
